## libappimage 0.1.9+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(libappimage)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

# versioning
set(V_MAJOR 0)
set(V_MINOR 1)
set(V_PATCH 9)

include(cmake/tools.cmake)
include(cmake/dependencies.cmake)

# used by e.g., Debian packaging infrastructure
include(GNUInstallDirs)

add_subdirectory(lib)
add_subdirectory(src)

include(CTest)
add_subdirectory(tests)

=== src/CMakeLists.txt ===
# required for pkg-config to create PkgConfig::<prefix> imported library targets
cmake_minimum_required(VERSION 3.6)

find_package(PkgConfig)

pkg_check_modules(glib glib-2.0>=2.40 IMPORTED_TARGET)
pkg_check_modules(gobject gobject-2.0>=2.40 IMPORTED_TARGET)
pkg_check_modules(gio gio-2.0>=2.40 IMPORTED_TARGET)
pkg_check_modules(zlib zlib IMPORTED_TARGET)
pkg_check_modules(cairo cairo IMPORTED_TARGET)

add_subdirectory(xdg-basedir)
add_subdirectory(libappimage_hashlib)
add_subdirectory(libappimage_shared)
add_subdirectory(libappimage)

# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
export(PACKAGE libappimage)

include(CMakePackageConfigHelpers)

# Create the AppImageConfig.cmake and AppImageConfigVersion files
configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/libappimageConfig.cmake.in"
    "${PROJECT_BINARY_DIR}/${CMAKE_FILES_DIRECTORY}/libappimageConfig.cmake"
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libappimage
)
# ... for both
configure_file(
    "${PROJECT_SOURCE_DIR}/cmake/libappimageConfigVersion.cmake.in"
    "${PROJECT_BINARY_DIR}/${CMAKE_FILES_DIRECTORY}/libappimageConfigVersion.cmake"
    @ONLY
)

# Install the AppImageConfig.cmake and AppImageConfigVersion.cmake
install(FILES
    "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/libappimageConfig.cmake"
    "${PROJECT_BINARY_DIR}/${CMAKE_FILES_DIRECTORY}/libappimageConfigVersion.cmake"
    "${PROJECT_SOURCE_DIR}/cmake/scripts.cmake"
    "${PROJECT_SOURCE_DIR}/cmake/imported_dependencies.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libappimage
    COMPONENT libappimage-dev
)

# Install the export set for use with the install-tree
install(EXPORT libappimageTargets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libappimage
    COMPONENT libappimage-dev
)

=== tests/CMakeLists.txt ===
# build and add test only if tests are enabled
include(CTest)
if(BUILD_TESTING)
    cmake_minimum_required(VERSION 3.5)

    set(CMAKE_CXX_STANDARD 98)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)

    # global definitions
    add_definitions(
        -DTEST_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data/"
        -DGIT_COMMIT="AppImageKit unit tests"
    )

    add_library(fixtures INTERFACE)
    target_sources(fixtures INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/fixtures.h)
    set_property(TARGET fixtures PROPERTY INTERFACE_LINK_LIBRARIES xdg-basedir gtest)

    add_executable(test_libappimage test_libappimage.cpp)
    target_link_libraries(test_libappimage fixtures libappimage libsquashfuse)
    add_test(test_libappimage test_libappimage)

    add_executable(test_shared test_shared.cpp)
    target_link_libraries(test_shared fixtures libappimage_shared)
    add_test(test_shared test_shared)
    # needed for some const->non-const conversions
    target_compile_options(test_shared PRIVATE -fpermissive)

    add_executable(test-xdg-basedir test-xdg-basedir.cpp)
    target_link_libraries(test-xdg-basedir fixtures xdg-basedir)
    add_test(test-xdg-basedir test-xdg-basedir)

    add_executable(test_desktop_integration test_desktop_integration.cpp file_management_utils.hpp)
    target_include_directories(test_desktop_integration PRIVATE "${PROJECT_SOURCE_DIR}/src/libappimage")
    target_link_libraries(test_desktop_integration libappimage libappimage_shared libsquashfuse gtest gtest_main)
    add_test(test_desktop_integration test_desktop_integration)
endif()

=== src/xdg-basedir/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# force static linking
add_library(xdg-basedir STATIC xdg-basedir.h xdg-basedir.c)
target_include_directories(xdg-basedir PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

## libappimage 0.1.9%2Bdfsg

=== debian/control ===
Source: libappimage
Priority: optional
Maintainer: Scarlett Moore <sgmoore@kde.org>
Build-Depends: cmake,
               debhelper (>= 12),
               desktop-file-utils,
               libarchive-dev,
               libcairo2-dev,
               libglib2.0-dev,
               libgtest-dev,
               liblzma-dev,
               libsquashfuse-dev,
               xxd,
Standards-Version: 4.3.0
Section: libs
Homepage: https://github.com/AppImage/libappimage
Vcs-Browser: https://salsa.debian.org/sgclark-guest/libappimage
Vcs-Git: https://salsa.debian.org/sgclark-guest/libappimage.git

Package: libappimage-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libappimage0 (= ${binary:Version}), ${misc:Depends}
Description: Development files for libappimage
 Core library of the AppImage project. Reference implementation
 of the AppImage specification. https://appimage.org
 .
 AppImage provides a way for upstream developers to provide
 “native” binaries for Linux users just the same way they could
 do for other operating systems. It allow packaging applications
 for any common Linux based operating system, e.g., Ubuntu,
 Debian, openSUSE, RHEL, CentOS, Fedora etc. AppImages
 come with all dependencies that cannot be assumed to be part
 of each target system in a recent enough version and will run
 on most Linux distributions without further modifications.
 .
 AppImage is the format, and AppImageKit provides a
 reference implementation.
 .
 This package contains the development files for libappimage.

Package: libappimage0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Core library for appimage
 Core library of the AppImage project. Reference implementation
 of the AppImage specification. https://appimage.org
 .
 AppImage provides a way for upstream developers to provide
 “native” binaries for Linux users just the same way they could
 do for other operating systems. It allow packaging applications
 for any common Linux based operating system, e.g., Ubuntu,
 Debian, openSUSE, RHEL, CentOS, Fedora etc. AppImages
 come with all dependencies that cannot be assumed to be part
 of each target system in a recent enough version and will run
 on most Linux distributions without further modifications.
 .
 AppImage is the format, and AppImageKit provides a
 reference implementation.
 .
 This library is used by some tools used to ease the installation
 and usage of appimages.
 .
 This package contains the library for libappimage.

## libappimage 0.1.9+dfsg

=== debian/changelog ===
libappimage (0.1.9+dfsg-1) unstable; urgency=medium

  * Add a better description. (Closes: #921072)
  * New upstream releaase.
  * Refresh symbols file.
  * Add --as-needed linker to avoid useless dependencies.
  * Add upstream patch to rid of build-path in binary, thus
    getting rid of lintian error.
  * Release to unstable.

 -- Scarlett Moore <sgmoore@kde.org>  Sun, 10 Feb 2019 06:08:27 -0700

libappimage (0.1.8+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #912287)

 -- Scarlett Moore <sgmoore@kde.org>  Fri, 11 Jan 2019 10:28:31 -0700

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//, \
filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/Appimage/libappimage/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## libappimage 0.1.10%2Bdfsg

=== src/libappimage_hashlib/CMakeLists.txt ===
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(public_header ${CMAKE_CURRENT_SOURCE_DIR}/include/hashlib.h)

add_library(libappimage_hashlib STATIC md5.c ${public_header})
set_target_properties(libappimage_hashlib PROPERTIES PREFIX "")
target_include_directories(libappimage_hashlib
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
)

# install libappimage
install(TARGETS libappimage_hashlib
    EXPORT libappimageTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libappimage
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libappimage
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/appimage COMPONENT libappimage-dev
)

=== debian/control ===
--- 
+++ 
@@ -21,7 +21,9 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libappimage0 (= ${binary:Version}), ${misc:Depends}
+Depends: libappimage0 (= ${binary:Version}),
+         libcairo2-dev,
+         ${misc:Depends}
 Description: Development files for libappimage
  Core library of the AppImage project. Reference implementation
  of the AppImage specification. https://appimage.org

## libappimage 0.1.10+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.2)
+cmake_minimum_required(VERSION 3.4)
 
 project(libappimage)
 
@@ -7,10 +7,12 @@
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
 
+include(cmake/reproducible_builds.cmake)
+
 # versioning
 set(V_MAJOR 0)
 set(V_MINOR 1)
-set(V_PATCH 9)
+set(V_PATCH 10)
 
 include(cmake/tools.cmake)
 include(cmake/dependencies.cmake)

=== src/libappimage/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

set(libappimage_public_header ${PROJECT_SOURCE_DIR}/include/appimage/appimage.h)

# both libraries use the same set of source files
set(libappimage_sources
    ${libappimage_public_header}
    libappimage.c
    appimage_handler.h
    appimage_handler.c
    type1.c
    type2.c
    desktop_integration.h
    desktop_integration.c
)

add_library(libappimage SHARED ${libappimage_sources} appimage_handler.h)
add_library(libappimage_static STATIC ${libappimage_sources})

# set common options
foreach(target libappimage libappimage_static)
    # targets are called lib* already, so CMake shouldn't add another lib prefix to the actual files
    set_target_properties(${target} PROPERTIES PREFIX "")

    target_compile_definitions(${target}
        # Support Large Files
        PRIVATE -D_FILE_OFFSET_BITS=64
        PRIVATE -D_LARGEFILE_SOURCE

        PRIVATE -DGIT_COMMIT="${GIT_COMMIT}"
        PRIVATE -DENABLE_BINRELOC
    )

    target_include_directories(${target}
        PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/>
        INTERFACE $<INSTALL_INTERFACE:include/>
    )

    target_link_libraries(${target}
        PRIVATE libarchive
        PRIVATE xdg-basedir
        # not linking publicly to squashfuse as headers are not needed when using libappimage
        # unit tests etc., which use squashfuse directly, must link to it explicitly
        PRIVATE libsquashfuse
        PRIVATE xz
        PUBLIC libappimage_shared
        PUBLIC pthread
        PUBLIC libglib
        PUBLIC libgobject
        PUBLIC libgio
        PUBLIC libzlib
        PUBLIC libcairo
    )

    set_property(TARGET libappimage PROPERTY PUBLIC_HEADER ${libappimage_public_header})

    set_property(TARGET libappimage PROPERTY VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH})
    set_property(TARGET libappimage PROPERTY SOVERSION ${V_MAJOR})
endforeach()

# install libappimage
install(TARGETS libappimage
    EXPORT libappimageTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libappimage
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libappimage
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/appimage COMPONENT libappimage-dev
)

# Add all targets to the build-tree export set
export(
    TARGETS libappimage libappimage_shared libappimage_hashlib
    FILE "${PROJECT_BINARY_DIR}/${CMAKE_FILES_DIRECTORY}/libappimageTargets.cmake"
)

=== debian/changelog ===
libappimage (0.1.10+dfsg-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Wed, 12 Jan 2022 09:33:31 -0500

libappimage (0.1.10+dfsg-0ubuntu1) groovy; urgency=medium

  * New upstream release (0.1.10)
  * Drop 0001-Make-release-builds-reproducible-mk.-1.patch, now included
    in the source.
  * Update symbols from build logs.
  * Add libcairo2-dev to -dev package depends.

 -- Rik Mills <rikmills@kde.org>  Thu, 25 Jun 2020 13:45:09 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: libappimage
 Priority: optional
-Maintainer: Scarlett Moore <sgmoore@kde.org>
+Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
+XSBC-Original-Maintainer: Scarlett Moore <sgmoore@kde.org>
 Build-Depends: cmake,
                debhelper (>= 12),
                desktop-file-utils,

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_configure:
	dh_auto_configure -- 	-DUSE_SYSTEM_XZ=ON -DUSE_SYSTEM_LIBARCHIVE=ON -DUSE_SYSTEM_SQUASHFUSE=ON \
	-DBUILD_TESTING=OFF -DCMAKE_BUILD_TYPE=Release

override_dh_missing:
	 dh_missing --fail-missing

## libappimage 1.0.3

=== debian/changelog ===
libappimage (1.0.3-1+20201123+2101+amd64+build24) 2101+amd64; urgency=medium

  [ Harald Sitter ]
  * New upstream release.

  [ Scarlett Moore ]
  * Update dependencies as per cmake and configure cmake flags to use
   system libraries.
  * Remove reproducible builds patch applied upstream.
  * Merge KDE Neon Packaging. Thanks!
  * Switch to debhelper-compat.
  * Update repo, moved to 3rdparty under kde umbrella.
  * Update symbols file.
    - Add symbolshelper-confirmed header to symbols file.
    - Rename file to new 1.0 SO version.
    - Update name in symbols file.
    - update new symbols / remove missing ( new SO version ).
  * Add rules-requires-root: no in d/control.
  * Update d/upstream/metadata.
    - Remove obsolete entries already defined in d/copyright.
    - Add bug-database entry.
  * Remove Priority extras ( lintian ).
  * Remove --as-needed flag as it is now default.
  * Bump Standards to 4.5.1; no changes.
  * Change to team maintainer.
  * Add googletest test dependency.
  * Add override to dh_clean to clean up test data.
  * Refresh copyright.
    - Add upstream-contact field.
    - Update file.
  * Using the library fails without runtime depend to xdg-utils-cxx.

  [ Debian CI ]
  * Automatic CI Build

 -- Debian CI <null@debian.org>  Fri, 12 Feb 2021 18:14:50 +0000

libappimage (1.0.2-0neon) focal; urgency=medium

  * New release

 -- Jonathan Riddell <jr@jriddell.org>  Wed, 24 Jul 2019 12:21:34 +0100

=== debian/control ===
--- 
+++ 
@@ -1,30 +1,41 @@
 Source: libappimage
 Priority: optional
-Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
-XSBC-Original-Maintainer: Scarlett Moore <sgmoore@kde.org>
+Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Uploaders: Scarlett Moore <sgmoore@kde.org>
 Build-Depends: cmake,
-               debhelper (>= 12),
+               debhelper-compat (= 12),
                desktop-file-utils,
                libarchive-dev,
+               libboost-filesystem-dev,
+               libboost-system-dev,
+               libboost-thread-dev,
                libcairo2-dev,
                libglib2.0-dev,
                libgtest-dev,
                liblzma-dev,
+               librsvg2-dev,
                libsquashfuse-dev,
+               pkg-config,
+               pkg-kde-tools,
+               xdg-utils-cxx-dev,
                xxd,
-Standards-Version: 4.3.0
+               zlib1g-dev
+Standards-Version: 4.5.1
 Section: libs
 Homepage: https://github.com/AppImage/libappimage
-Vcs-Browser: https://salsa.debian.org/sgclark-guest/libappimage
-Vcs-Git: https://salsa.debian.org/sgclark-guest/libappimage.git
+Rules-Requires-Root: no
+Vcs-Git: https://github.com/dci-extras-packaging/libappimage
+Vcs-Browser: https://github.com/dci-extras-packaging/libappimage
 
 Package: libappimage-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libappimage0 (= ${binary:Version}),
+Depends: libappimage1.0 (= ${binary:Version}),
          libcairo2-dev,
-         ${misc:Depends}
+         librsvg2-dev,
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: Development files for libappimage
  Core library of the AppImage project. Reference implementation
  of the AppImage specification. https://appimage.org
@@ -43,10 +54,12 @@
  .
  This package contains the development files for libappimage.
 
-Package: libappimage0
+Package: libappimage1.0
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Breaks: libappimage0 (<< 0.1.9+dfsg-1)
+Replaces: libappimage0 (<< 0.1.9+dfsg-1)
 Description: Core library for appimage
  Core library of the AppImage project. Reference implementation
  of the AppImage specification. https://appimage.org
@@ -67,3 +80,10 @@
  and usage of appimages.
  .
  This package contains the library for libappimage.
+
+Package: libappimage0
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Section: oldlibs
+Description: Core library for appimage - transitional
+ This is a dummy transitional package which can be removed

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SYSTEM_XZ=ON -DUSE_SYSTEM_LIBARCHIVE=ON \
	-DUSE_SYSTEM_SQUASHFUSE=ON -DUSE_SYSTEM_BOOST=ON -DUSE_SYSTEM_XDGUTILS=ON \
	-DBUILD_TESTING=OFF -DCMAKE_BUILD_TYPE=Release

override_dh_missing:
	 dh_missing --fail-missing

override_dh_clean:
	 rm -rf $(CURDIR)/tests/data
	 dh_clean

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//, \
filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/Appimage/libappimage/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian

## libappimage 1.0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(libappimage)

set(V_MAJOR 1)
set(V_MINOR 0)
set(V_PATCH 3)
set(V_SUFFIX "")

set(libappimage_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH}${V_SUFFIX})

# more versioning
set(libappimage_SOVERSION ${V_MAJOR}.${V_MINOR})

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Optimize for size in release builds
set(CMAKE_CXX_FLAGS_RELEASE "-Os -DNDEBUG -Wl,--gc-sections")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

include(cmake/reproducible_builds.cmake)

option(LIBAPPIMAGE_DESKTOP_INTEGRATION_ENABLED "Enable desktop integration functions" On)
option(LIBAPPIMAGE_THUMBNAILER_ENABLED "Enable thumbnailer functions" On)
option(LIBAPPIMAGE_STANDALONE "Statically embbed dependencies" Off)
option(LIBAPPIMAGE_SHARED_ONLY "Build and distribute shared and hashlib only (for use with AppImageKit and AppImageUpdate)" Off)
option(ENABLE_COVERAGE "Enable tests code coverate target" Off)

# some dependencies are only checked when testing is enabled
include(CTest)

include(cmake/tools.cmake)
include(cmake/dependencies.cmake)

if(ENABLE_COVERAGE)
    message("Configuring project for code coverage mesurement")
    include(CodeCoverage)
    append_coverage_compiler_flags()
endif()

# used by e.g., Debian packaging infrastructure
include(GNUInstallDirs)

add_subdirectory(lib)
add_subdirectory(src)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile clean

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)


clean:
	rm -rf doxyoutput/ api/
	@$(SPHINXBUILD) -M clean "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/requirements.txt ===
exhale
sphinx>=2.0
sphinx_rtd_theme

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

include(CTest)

if(BUILD_TESTING)
    if(NOT TARGET gtest)
        if(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/gtest)
            add_subdirectory(gtest EXCLUDE_FROM_ALL)
        else()
            message(FATAL_ERROR "gtest submodule not found; please call git submodule update --init or disable the unit tests using -DBUILD_TESTING=OFF")
        endif()
    endif()
endif()

=== src/CMakeLists.txt ===
# required for pkg-config to create PkgConfig::<prefix> imported library targets
cmake_minimum_required(VERSION 3.6)

add_subdirectory(xdg-basedir)
add_subdirectory(libappimage_hashlib)
add_subdirectory(libappimage_shared)
if(NOT LIBAPPIMAGE_SHARED_ONLY)
    add_subdirectory(libappimage)
endif()

# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
export(PACKAGE libappimage)

include(CMakePackageConfigHelpers)

# Create the AppImageConfig.cmake and AppImageConfigVersion files
configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/libappimageConfig.cmake.in"
    "${PROJECT_BINARY_DIR}/${CMAKE_FILES_DIRECTORY}/libappimageConfig.cmake"
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libappimage
)
# ... for both
configure_file(
    "${PROJECT_SOURCE_DIR}/cmake/libappimageConfigVersion.cmake.in"
    "${PROJECT_BINARY_DIR}/${CMAKE_FILES_DIRECTORY}/libappimageConfigVersion.cmake"
    @ONLY
)

# Install the AppImageConfig.cmake and AppImageConfigVersion.cmake
install(
    FILES
    "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/libappimageConfig.cmake"
    "${PROJECT_BINARY_DIR}/${CMAKE_FILES_DIRECTORY}/libappimageConfigVersion.cmake"
    "${PROJECT_BINARY_DIR}/cmake/scripts.cmake"
    "${PROJECT_BINARY_DIR}/cmake/imported_dependencies.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libappimage
    COMPONENT libappimage-dev
)

# Install the export set for use with the install-tree
install(
    EXPORT libappimageTargets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libappimage
    COMPONENT libappimage-dev
)

if(NOT LIBAPPIMAGE_SHARED_ONLY)
    # pkg-config
    configure_file("${PROJECT_SOURCE_DIR}/cmake/libappimage.pc.in" "${PROJECT_BINARY_DIR}/libappimage.pc" @ONLY)

    install(FILES "${PROJECT_BINARY_DIR}/libappimage.pc"
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
        COMPONENT libappimage-dev
    )
endif()

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

# global definitions
add_definitions(
    -DTEST_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data/"
    -DGIT_COMMIT="AppImageKit unit tests"
)


add_subdirectory(libappimage)

if(ENABLE_COVERAGE)
    set(COVERAGE_LCOV_EXCLUDES '${PROJECT_SOURCE_DIR}/lib/*' '${PROJECT_SOURCE_DIR}/tests/*' '${PROJECT_SOURCE_DIR}/*build*' '/usr/*')
    setup_target_for_coverage_lcov(
        NAME coverage
        EXECUTABLE ctest -V -j ${PROCESSOR_COUNT}
        DEPENDENCIES test_libappimage++ TestDesktopIntegration test-xdg-basedir test_shared test_libappimage test_libappimage
    )
endif()

=== src/libappimage/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

add_subdirectory(core)
add_subdirectory(utils)

set(
    libappimage_sources
    libappimage.c
    libappimage.cpp
    $<TARGET_OBJECTS:core>
    $<TARGET_OBJECTS:appimage_utils>
)
if(LIBAPPIMAGE_DESKTOP_INTEGRATION_ENABLED)
    add_subdirectory(desktop_integration)
    list(APPEND libappimage_sources "$<TARGET_OBJECTS:appimage_desktop_integration>")
endif()

add_library(libappimage_static STATIC ${libappimage_sources})
add_library(libappimage SHARED ${libappimage_sources} libappimage_legacy.cpp)

configure_file(config.h.in ${PROJECT_BINARY_DIR}/generated-headers/appimage/config.h)

foreach(target libappimage libappimage_static)
    configure_libappimage_module(${target})
    target_link_libraries(
        ${target}
        PRIVATE libarchive
        PRIVATE xdg-basedir
        PRIVATE XdgUtils::DesktopEntry
        PRIVATE XdgUtils::BaseDir
        PRIVATE libappimage_hashlib
        # not linking publicly to squashfuse as headers are not needed when using libappimage
        # unit tests etc., which use squashfuse directly, must link to it explicitly
        PRIVATE libsquashfuse
        PRIVATE xz
        PRIVATE Boost::filesystem
        PUBLIC libappimage_shared
        PUBLIC pthread
        PRIVATE libgio
        PRIVATE libzlib
        PUBLIC libcairo
        PUBLIC librsvg
        PUBLIC dl
    )
    message(STATUS "IMAGE_MANIPULATION_BACKEND_LIBS ${IMAGE_MANIPULATION_BACKEND_LIBS}")
    if(LIBAPPIMAGE_STANDALONE)
        target_link_libraries(${target} PRIVATE -static-libgcc -static-libstdc++)
    endif()

    target_include_directories(
        ${target}
        PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        PUBLIC $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/generated-headers>
    )

    set_property(TARGET libappimage PROPERTY PUBLIC_HEADER ${libappimage_public_header})

    set_property(TARGET libappimage PROPERTY VERSION ${libappimage_VERSION})
    set_property(TARGET libappimage PROPERTY SOVERSION ${libappimage_SOVERSION})
endforeach()


# install libappimage
install(
    TARGETS libappimage
    EXPORT libappimageTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libappimage
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libappimage
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/appimage COMPONENT libappimage-dev
)

# install public headers
install(
    DIRECTORY ${PROJECT_SOURCE_DIR}/include/appimage/
    DESTINATION include/appimage
    COMPONENT libappimage-dev
)

install(
    DIRECTORY ${PROJECT_BINARY_DIR}/generated-headers/appimage/
    DESTINATION include/appimage
    COMPONENT libappimage-dev
)

# Add all targets to the build-tree export set
export(
    TARGETS libappimage libappimage_shared libappimage_hashlib
    FILE "${PROJECT_BINARY_DIR}/${CMAKE_FILES_DIRECTORY}/libappimageTargets.cmake"
)

=== src/libappimage_hashlib/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
-set(public_header ${CMAKE_CURRENT_SOURCE_DIR}/include/hashlib.h)
+set(public_header ${CMAKE_CURRENT_SOURCE_DIR}/include/hashlib.h ../../include/appimage/appimage_legacy.h)
 
 add_library(libappimage_hashlib STATIC md5.c ${public_header})
 set_target_properties(libappimage_hashlib PROPERTIES PREFIX "")

=== src/libappimage_shared/CMakeLists.txt ===
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(libappimage_shared_public_header ${PROJECT_SOURCE_DIR}/include/appimage/appimage_shared.h)

add_library(libappimage_shared STATIC
    ${libappimage_shared_public_header}
    elf.c
    hexlify.c
    light_byteswap.h
    light_elf.h
    digest.c
)
set_target_properties(libappimage_shared PROPERTIES PREFIX "")
target_include_directories(libappimage_shared PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)
set_property(TARGET libappimage_shared PROPERTY PUBLIC_HEADER ${libappimage_shared_public_header})
target_link_libraries(libappimage_shared PRIVATE libappimage_hashlib)

# install libappimage
install(TARGETS libappimage_shared
    EXPORT libappimageTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libappimage
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libappimage
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/appimage COMPONENT libappimage-dev
)

=== tests/client_app/CMakeLists.txt ===
project(client_app)
cmake_minimum_required(VERSION 3.0)

find_package(libappimage REQUIRED)

add_executable(client_app main.c)
target_link_libraries(client_app libappimage)

=== tests/libappimage/CMakeLists.txt ===
add_subdirectory(legacy)

if (NOT LIBAPPIMAGE_SHARED_ONLY)
    if(LIBAPPIMAGE_DESKTOP_INTEGRATION_ENABLED)
        add_subdirectory(desktop_integration)
    endif()

    add_executable(
        test_libappimage++

        TestLibappimage++.cpp

        core/impl/TestTraversalType1.cpp
        core/impl/TestTraversalType2.cpp

        utils/TestMagicBytesChecker.cpp
        utils/TestUtilsElf.cpp
        utils/TestIconHandle.cpp
        utils/TestLogger.cpp
        utils/TestPayloadEntriesCache.cpp
        utils/TestResourcesExtractor.cpp
        utils/StringSanitizerTest.cpp
    )

    target_include_directories(test_libappimage++ PRIVATE "${PROJECT_SOURCE_DIR}/src/libappimage")
    target_link_libraries(test_libappimage++ libappimage Boost::filesystem libarchive libsquashfuse XdgUtils::DesktopEntry XdgUtils::BaseDir gtest gtest_main)

    add_test(test_libappimage++ test_libappimage++)
endif()

=== src/libappimage/core/CMakeLists.txt ===
add_library(
    core OBJECT
    AppImage.cpp
    Traversal.h
    Traversal.cpp
    PayloadIterator.cpp
    impl/TraversalType1.cpp
    impl/TraversalType2.cpp
    impl/StreambufType1.cpp
    impl/StreambufType2.cpp
)

target_include_directories(
    core
    PRIVATE $<TARGET_PROPERTY:Boost::filesystem,INTERFACE_INCLUDE_DIRECTORIES>
    PRIVATE $<TARGET_PROPERTY:libappimage_hashlib,INTERFACE_INCLUDE_DIRECTORIES>
    PRIVATE $<TARGET_PROPERTY:XdgUtils::DesktopEntry,INTERFACE_INCLUDE_DIRECTORIES>
    PRIVATE $<TARGET_PROPERTY:libarchive,INTERFACE_INCLUDE_DIRECTORIES>
    PRIVATE $<TARGET_PROPERTY:libsquashfuse,INTERFACE_INCLUDE_DIRECTORIES>
    PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/..
)

configure_libappimage_module(core)
add_dependencies(core Boost::filesystem libappimage_hashlib XdgUtils::DesktopEntry libarchive libsquashfuse)

## libappimage 1.0.4-5

=== debian/changelog ===
libappimage (1.0.4-5-6) unstable; urgency=medium

  * Team upload.
  * Update symbols file from the logs of buildds; mark more private symbols as
    optional.

 -- Pino Toscano <pino@debian.org>  Fri, 26 Sep 2025 06:10:37 +0200

libappimage (1.0.4-5-5) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Backport upstream commit e5f6ea562611d534dc8e899a12ddf15c50e820be to require
    CMake 3.6; patch upstream_Bump-minimum-CMake-version-to-3.6.patch.
    (Closes: #1113112)
  * CI: simplify/update configuration.
  * Update symbols file from the logs of buildds; drop bits for discontinued
    ia64, and mipsel architectures.
  * Drop no more needed lintian overrides.

 -- Pino Toscano <pino@debian.org>  Sat, 20 Sep 2025 11:49:35 +0200

libappimage (1.0.4-5-4) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Update symbols from build for 1.0.4-5. (Closes: #1075143)
  * Switch build dependency from transitional pkg-config to pkgconf.
  * Bump Standards-Version to 4.7.0, no change required.

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 01 Aug 2024 01:21:24 +0200

libappimage (1.0.4-5-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063122

 -- Benjamin Drung <bdrung@debian.org>  Fri, 01 Mar 2024 12:18:58 +0000

libappimage (1.0.4-5-3) unstable; urgency=medium

  * Team upload.
  * Update symbols files from the logs of buildds.
  * Mark the internal boost-related symbols as optional, as they can change
    depending on the boost version.

 -- Pino Toscano <pino@debian.org>  Tue, 19 Dec 2023 18:16:16 +0100

libappimage (1.0.4-5-2) unstable; urgency=medium

  * Team upload.
  * Switch the transitional xdg-utils-cxx build dependency to xdg-utils-cxx-dev.
  * Backport upstream commit 1e0515b23b90588ce406669134feca56ddcbbe43 to fix
    the build with GCC 13; patch upstream_Fix-build-with-gcc-13.1.1.patch.
    (Closes: #1037716)
  * Update symbols file.

 -- Pino Toscano <pino@debian.org>  Fri, 14 Jul 2023 08:02:51 +0200

libappimage (1.0.4-5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Fix & simplify the watch file, using the newer template provided by
    uscan(1); drop almost all the options, no more needed now.
  * Update the patches:
    - disable_wget_dependency.patch: drop, no more needed
    - enable_debianabimanager.diff: refresh
  * Update the build dependencies according to the upstream build system:
    - drop desktop-file-utils, libboost-thread-dev, libboost-system-dev, and
      xxd, no more needed

 -- Pino Toscano <pino@debian.org>  Mon, 02 Jan 2023 08:20:13 +0100

libappimage (1.0.4-4) unstable; urgency=medium

  * Team upload.
  * Drop patch update_cmake_to_look_for_dependency_targets.patch: in addition
    to a typo that makes libappimageConfig.cmake an invalid cmake script,
    the XdgUtils libraries are not actually exposed as public dependencies.
  * Update the dependencies of libappimage-dev to reflect what is actually
    searched by the cmake scripts:
    - drop xdg-utils-cxx
    - explicitly add libglib2.0-dev, and zlib1g-dev
  * Hack my previous hack in the patch enable_debianabimanager.diff to make sure
    that CMAKE_BUILD_TYPE is set at the of the top-level CMakeLists.txt as it
    was passed to cmake; this fixes the generation of the cmake configuration
    files for the exported targets.

 -- Pino Toscano <pino@debian.org>  Wed, 28 Dec 2022 08:59:18 +0100

libappimage (1.0.4-3) unstable; urgency=medium

  * Team upload.
  * Drop the transitional libappimage0 binary: it is empty, it does not depend
    on anything, and it cannot pull the actual library as it has a different
    ABI.
  * Drop the 'testsuite' autopkgtest: it does not test the installed package,
    and it actually does nothing since the tests are disabled during the build
    (-DBUILD_TESTING=OFF is passed to cmake).
  * Update lintian override info format in d/source/lintian-overrides on line 2,
    6.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.
  * Update the other metadata fields to the actual upstream location.
  * Replace patch upstream_fix_typos.patch with the upstream commit
    e456429dafaee3245f6e7925b64d5990ad5affe7; patch
    upstream_Fix-typos-Unsuported-Unsupported-180.patch.
  * Make sure DebianABIManager is actually applied:
    - rename the X-Debian-Abi field to X-Debian-ABI, as used by DebianABIManager
    - add X-CMake-Target: libappimage to specify the actual target to handle
    - extend the patch enable_debianabimanager.diff with some manual gymnastics:
      DebianABIManager works only with a "Debian" CMAKE_BUILD_TYPE, so
      - to set it like that before including DebianABIManager (it's the very
        last bit in the top-level CMakeLists.txt, so it is fine)
      - append the link flags (which include the linker script) specified for
        the "Debian" build type to the link flags in use
    - in the symbols file:
      - switch the actual file name to libappimage.so.1.0abi1
      - switch the version of all the symbols from "Base" (i.e. none) to
        ABI_1.0_1
      - add the ABI tag symbol
    - drop the libappimage0 breaks/replaces, since the library names do not
      conflict with non-ABI ones
  * Improve the install files to be more precise.
  * Drop the libgtest-dev build dependency, as it is not needed (the tests are
    not built).

 -- Pino Toscano <pino@debian.org>  Tue, 27 Dec 2022 14:45:27 +0100

libappimage (1.0.4-2) unstable; urgency=medium

  * Update symbols file from buildd logs.

 -- Scarlett Moore <sgmoore@debian.org>  Tue, 27 Dec 2022 03:42:15 -0700

libappimage (1.0.4-1) unstable; urgency=medium

  [ Harald Sitter ]
  * New upstream release.

  [ Scarlett Moore ]


=== debian/control ===
--- 
+++ 
@@ -1,41 +1,36 @@
 Source: libappimage
 Priority: optional
 Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
-Uploaders: Scarlett Moore <sgmoore@kde.org>
-Build-Depends: cmake,
-               debhelper-compat (= 12),
-               desktop-file-utils,
+Uploaders: Scarlett Moore <sgmoore@debian.org>
+Build-Depends: dpkg-dev (>= 1.22.5), cmake,
+               debhelper-compat (= 13),
                libarchive-dev,
-               libboost-filesystem-dev,
-               libboost-system-dev,
-               libboost-thread-dev,
                libcairo2-dev,
                libglib2.0-dev,
-               libgtest-dev,
                liblzma-dev,
+               libboost-filesystem-dev,
                librsvg2-dev,
                libsquashfuse-dev,
-               pkg-config,
+               pkgconf,
                pkg-kde-tools,
                xdg-utils-cxx-dev,
-               xxd,
-               zlib1g-dev
-Standards-Version: 4.5.1
+               zlib1g-dev,
+Standards-Version: 4.7.2
 Section: libs
-Homepage: https://github.com/AppImage/libappimage
-Rules-Requires-Root: no
-Vcs-Git: https://github.com/dci-extras-packaging/libappimage
-Vcs-Browser: https://github.com/dci-extras-packaging/libappimage
+Homepage: https://github.com/AppImageCommunity/libappimage
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/libappimage
+Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/libappimage.git
 
 Package: libappimage-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libappimage1.0 (= ${binary:Version}),
+Depends: libappimage1.0abi1t64 (= ${binary:Version}),
          libcairo2-dev,
+         libglib2.0-dev,
          librsvg2-dev,
-         ${misc:Depends},
-         ${shlibs:Depends}
+         zlib1g-dev,
+         ${misc:Depends}
 Description: Development files for libappimage
  Core library of the AppImage project. Reference implementation
  of the AppImage specification. https://appimage.org
@@ -54,12 +49,15 @@
  .
  This package contains the development files for libappimage.
 
-Package: libappimage1.0
+Package: libappimage1.0abi1t64
+Provides: ${t64:Provides}
+Replaces: libappimage1.0abi1
+Breaks: libappimage1.0abi1 (<< ${source:Version})
+X-Debian-ABI: 1
+X-CMake-Target: libappimage
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Breaks: libappimage0 (<< 0.1.9+dfsg-1)
-Replaces: libappimage0 (<< 0.1.9+dfsg-1)
 Description: Core library for appimage
  Core library of the AppImage project. Reference implementation
  of the AppImage specification. https://appimage.org
@@ -80,10 +78,3 @@
  and usage of appimages.
  .
  This package contains the library for libappimage.
-
-Package: libappimage0
-Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Section: oldlibs
-Description: Core library for appimage - transitional
- This is a dummy transitional package which can be removed

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with pkgkde-symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SYSTEM_XZ=ON -DUSE_SYSTEM_LIBARCHIVE=ON \
	-DUSE_SYSTEM_SQUASHFUSE=ON -DUSE_SYSTEM_BOOST=ON -DUSE_SYSTEM_XDGUTILS=ON \
	-DBUILD_TESTING=OFF -DCMAKE_BUILD_TYPE=Release

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
  https://github.com/AppImageCommunity/libappimage/tags \
  (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
